]> git.sesse.net Git - backup.sh/blobdiff - backup.sh
Fix a stray \\n in a message.
[backup.sh] / backup.sh
index 075f89ad02502223901be9530af16f26403727b2..6352fcebdff1b3a5eef94053292b9f58aea60ddc 100755 (executable)
--- a/backup.sh
+++ b/backup.sh
@@ -11,9 +11,6 @@
 # It's a bit peculiar, but quite effective. The following is worth keeping in
 # mind when hacking:
 #
-# KISS. And by that I mean really simple. Only regular Unix commands, please
-# (but GNU extensions are used and moreutils has to be installed).
-#
 # Because of the way we run this script from cron, informational logging goes
 # to stderr and warnings and errors to stdout. This way, we get mail whenever
 # stuff fails, and other output is redirected to the log file.
@@ -47,53 +44,61 @@ fi
 
 # Die more or less gracefully (at least notify user)
 die() {
-       echo `date`": Something nasty happened."
+       warnmsg "Aborting."
        rm $LOCKFILE
        exit 1
 }
+diemsg() {
+       warnmsg "$@"
+       die
+}
+warnmsg() {
+       echo `date`": $computer: $@"
+       echo `date`": $computer: $@" >&2
+}
+infomsg() {
+       echo `date`": $computer: $@" >&2
+}
 
 # Trap C-c and kill
 trap die SIGINT SIGTERM
 
 # Don't start if we're already running
 if [ -e $LOCKFILE ]; then
-       echo `date`": $LOCKFILE exists for pid `cat $LOCKFILE`, exiting."
-       echo `date`": $LOCKFILE exists for pid `cat $LOCKFILE`, exiting." >&2
-       exit 1
+       diemsg "$LOCKFILE exists for pid `cat $LOCKFILE`."
 fi;
 touch $LOCKFILE
 echo $$ > $LOCKFILE
 
-echo `date`": Backup run starting" >&2
+infomsg "Backup run starting"
 
 umask 027
 
-
 backup()
 {
-       echo -n `date` >&2
-       printf " $computer: $computer:$filesystem $backuplevel backup\n" >&2
+       infomsg "$computer:$filesystem $backuplevel backup"
 
-       SNARFILE="${storagedir}/${computer}/${sfilesystem}/.incremental.snar"
-       incrementalsnar="/root/.backup/${sfilesystem}.snar"
-       if [ "$backuplevel" = "daglig" ]
-       then
+       localsnar="${storagedir}/${computer}/${sfilesystem}/.incremental.snar"
+       remotesnar="/root/.backup/${sfilesystem}.snar"
+       if [ "$backuplevel" = "daglig" ]; then
                # If incremental backup, we need to copy the incremental status to $computer.
                # If it does not exist, whine a bit and then run date-based instead.
-               if [ -s "$SNARFILE" ]; then
-                       if ! scp $SNARFILE root@$computer:$incrementalsnar; then
-                               echo `date`" $computer: Could not copy .incremental.snar to $computer"
-                               die
+               if [ -s "$localsnar" ]; then
+                       if ! scp $localsnar root@$computer:$remotesnar; then
+                               diemsg "Could not copy .incremental.snar to $computer"
                        fi
-                       lastcmd="--listed-incremental=$incrementalsnar --no-check-device"
+                       lastcmd="--listed-incremental=$remotesnar --no-check-device"
                else
-                       echo `date`" $computer: Missing incremental.snar for $filesystem, doing date-based backup instead until next full backup" >&2
-                       incrementalsnar=""
+                       infomsg "Missing incremental.snar for $filesystem, doing date-based backup instead until next full backup"
+                       remotesnar=""
                        lastd=`cat ../.date`
                        lastcmd="--newer='$lastd'"
                fi
        else
-               lastcmd="--listed-incremental=$incrementalsnar"
+               # Note: Since we rm-ed .backup previously, and we don't scp over
+               # anything in this branch, this file will not exist, and we
+               # will be doing a full backup (but we want the output of it).
+               lastcmd="--listed-incremental=$remotesnar"
        fi
 
        # We try to run tar on the remote computer
@@ -109,20 +114,23 @@ backup()
        TARFILE=$DATE.tmp
        TARCMD="ssh root@$computer \"nice -n 19 ionice -c3 tar --one-file-system --use-compress-program $compressor -cf - -C $filesystem . $lastcmd \
                --exclude-from=/root/.backup/exclude\" | pee \"cat > $TARFILE\" \"tar tzvf -\""
-       echo `date`" $computer: Running $TARCMD" >&2
+       infomsg "Running $TARCMD"
        eval $TARCMD > $DATE.idx
 
        if [ $? -eq 0 ] && [ -s $TARFILE ]; then
                # File is >0 in size and neither cat or tar tzvf failed; we assume it worked.
-
-               if ! scp root@$computer:$incrementalsnar $SNARFILE.tmp; then
-                       echo `date`" $computer: Could not copy .incremental.snar from $computer"
-                       die
+               if [ "$remotesnar" ]; then
+                       if ! scp root@$computer:$remotesnar $localsnar.tmp; then
+                               diemsg "Could not copy .incremental.snar from $computer"
+                       fi
                fi
 
                # Move tar file in place
                mv $TARFILE $DATE.tgz
-               mv $SNARFILE.tmp $SNARFILE
+               if [ "$remotesnar" ]; then
+                       mv $localsnar.tmp $localsnar
+               fi
 
                # Update timestamp
                echo $DATEs > ../.date && touch -t $DATE ../.date
@@ -139,37 +147,33 @@ backup()
        else
                # Something wrong happened.
                rm $TARFILE
-               echo `date`" $computer: $TARFILE empty. $backuplevel backup of $computer:$filesystem failed and deleted"
-               die
+               diemsg "tar failed or $TARFILE empty. $backuplevel backup of $computer:$filesystem failed and deleted"
        fi
 }
 
 # Check that the target filesystem is mounted (actually check that it's not
 # the root filesystem)
 if [ ! -d "$storagedir/$computer" ]; then
-       echo `date`" $computer: Target filesystem ($storagedir/$computer) does not exist. Aborting"
-       die
+       diemsg "Target filesystem ($storagedir/$computer) does not exist."
 fi
 rootfilesystem=`df -P /`
 targetfilesystem=`df -P "$storagedir/$computer"`
 if [ "$rootfilesystem" == "$targetfilesystem" ]; then
-       echo `date`" $computer: Target filesystem ($storagedir/$computer) was mounted on /. Aborting"
-       die
+       diemsg "Target filesystem ($storagedir/$computer) was mounted on /."
 fi
 
-echo `date`" $computer: Backing up $computer" >&2
+infomsg "Backing up $computer"
 
 # Try to SSH to the computer without entering a password.
-if ! `ssh -n -o NumberOfPasswordPrompts=0 root@$computer /bin/true`; then
-       echo `date`" $computer: Could not use passwordless SSH."
-       die
+if ! ssh -n -o NumberOfPasswordPrompts=0 root@$computer /bin/true; then
+       diemsg "Could not use passwordless SSH."
 fi
 
 # Check if pigz is available
 if ssh -n root@$computer "pigz -V 2>/dev/null"; then
        compressor=pigz
 else
-       echo `date`" $computer: pigz missing; falling back to gzip."
+       infomsg "pigz missing; falling back to gzip."
        compressor=gzip
 fi
 
@@ -182,38 +186,32 @@ filesystems=`ssh -n root@$computer "cat /etc/fstab" \
 
 # Clean up our dir at this client
 if ! ssh root@$computer "rm -r /root/.backup ; mkdir -m 700 /root/.backup"; then
-       echo `date`" $computer: Could not create backup staging area at $computer:/root/.backup"
-       die
+       diemsg "Could not create backup staging area at $computer:/root/.backup"
 fi
 
 # Try to copy $exclude to $computer
 if ! scp $exclude root@$computer:/root/.backup/exclude > /dev/null; then
-       echo `date`" $computer: Could not copy exclude.txt to $computer"
-       die
+       diemsg "Could not copy exclude.txt to $computer"
 fi
 
 # Try to copy preeexec and postexec if they exist
 if [ -f $confdir/preexec.$computer ]; then
        if ! scp $confdir/preexec.$computer  root@$computer:/root/.backup/preexec >&2; then
-               echo `date`" $computer: Could not copy preexec.$computer to $computer:/root/.backup/preexec"
-               die
+               diemsg "Could not copy preexec.$computer to $computer:/root/.backup/preexec"
        fi
 fi
 if [ -f $confdir/postexec.$computer ]; then
        if ! scp $confdir/postexec.$computer root@$computer:/root/.backup/postexec >&2; then
-               echo `date`" $computer: Could not copy postexec.$computer to $computer:/root/.backup/postexec"
-               die
+               diemsg "Could not copy postexec.$computer to $computer:/root/.backup/postexec"
        fi
 fi
 
 # Try to run preexec if it exists
 if ! ssh root@$computer "[ ! -f /root/.backup/preexec ] || /bin/bash -x /root/.backup/preexec" >&2; then
-       echo `date`" $computer: Could not run $computer:/root/.backup/preexec"
-       die
+       diemsg "Could not run $computer:/root/.backup/preexec"
 fi
 
-for filesystem in $filesystems
-do
+for filesystem in $filesystems; do
        # Remove / and $ (for Windows) for path names
        sfilesystem=`echo $filesystem | tr '\/\$' '__'`
 
@@ -224,11 +222,9 @@ do
        # Default backuplevel
        backuplevel=daglig
 
-       if [ ! -f $storagedir/$computer/$sfilesystem/.date ]
-       then
+       if [ ! -s $storagedir/$computer/$sfilesystem/.date ]; then
                # Take the first full backup of this filesystem on this computer
                backuplevel=full
-               echo $DATEs > $storagedir/$computer/$sfilesystem/.date
        fi
 
        # Check if we want a full backup
@@ -251,23 +247,24 @@ do
        fi
 
        # We want to be here
-       cd $storagedir/$computer/$sfilesystem/$backuplevel || die
+       cd $storagedir/$computer/$sfilesystem/$backuplevel || diemsg "$storagedir/$computer/$sfilesystem/$backuplevel does not exist"
 
        # Perform the actual backup
        backup
 
        # Check if this box has a custom number of full backups
-       if [ -f $confdir/maksfulle.$computer ] ; then
+       if [ -f $confdir/maksfulle.$computer.$sfilesystem ]; then
+               mf=$((`cat $confdir/maksfulle.$computer`+1))
+       elif [ -f $confdir/maksfulle.$computer ] ; then
                mf=$((`cat $confdir/maksfulle.$computer`+1))
        else
                mf=$(($maxnumfull+1))
        fi
 
        # Delete old full backups
-       for full in `ls -1t $storagedir/$computer/$sfilesystem/full/*tgz | tail -n +$mf`
-       do
+       for full in `ls -1t $storagedir/$computer/$sfilesystem/full/*tgz | tail -n +$mf`; do
                prefix=`echo $full | sed "s/\.[^.]*$//"`
-               echo `date`": $computer:$filesystem Deleting full backup $prefix" >&2
+               infomsg "$computer:$filesystem Deleting full backup $prefix"
                rm $prefix*
        done
 
@@ -283,9 +280,11 @@ done
 
 # Try to run postexec if it exist
 if ! ssh root@$computer "[ ! -f /root/.backup/postexec ] || /bin/bash -x /root/.backup/postexec" >&2; then
-       echo `date`" $computer: Could not run $computer:/root/.backup/postexec"
-       die
+       diemsg "Could not run $computer:/root/.backup/postexec"
 fi
 
+# Use warn so that we will get an email even on success.
+warnmsg "$computer: Backup completed successfully."
+
 # Remove lockfile
 rm $LOCKFILE